# coding: utf-8

"""
    Genomic Data Store Service

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from libica.openapi.libgds.configuration import Configuration


class CreateFolderRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'folder_path': 'str',
        'volume_id': 'str',
        'volume_name': 'str',
        'acl': 'list[str]'
    }

    attribute_map = {
        'name': 'name',
        'folder_path': 'folderPath',
        'volume_id': 'volumeId',
        'volume_name': 'volumeName',
        'acl': 'acl'
    }

    def __init__(self, name=None, folder_path=None, volume_id=None, volume_name=None, acl=None, local_vars_configuration=None):  # noqa: E501
        """CreateFolderRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._folder_path = None
        self._volume_id = None
        self._volume_name = None
        self._acl = None
        self.discriminator = None

        self.name = name
        if folder_path is not None:
            self.folder_path = folder_path
        if volume_id is not None:
            self.volume_id = volume_id
        if volume_name is not None:
            self.volume_name = volume_name
        if acl is not None:
            self.acl = acl

    @property
    def name(self):
        """Gets the name of this CreateFolderRequest.  # noqa: E501

        Folder name, unique to this path, for the folder being created  # noqa: E501

        :return: The name of this CreateFolderRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateFolderRequest.

        Folder name, unique to this path, for the folder being created  # noqa: E501

        :param name: The name of this CreateFolderRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and not re.search(r'^[^\/]+$', name)):  # noqa: E501
            raise ValueError(r"Invalid value for `name`, must be a follow pattern or equal to `/^[^\/]+$/`")  # noqa: E501

        self._name = name

    @property
    def folder_path(self):
        """Gets the folder_path of this CreateFolderRequest.  # noqa: E501

        Path from the root folder to the location for the folder being created; must start and end with '/'  # noqa: E501

        :return: The folder_path of this CreateFolderRequest.  # noqa: E501
        :rtype: str
        """
        return self._folder_path

    @folder_path.setter
    def folder_path(self, folder_path):
        """Sets the folder_path of this CreateFolderRequest.

        Path from the root folder to the location for the folder being created; must start and end with '/'  # noqa: E501

        :param folder_path: The folder_path of this CreateFolderRequest.  # noqa: E501
        :type: str
        """

        self._folder_path = folder_path

    @property
    def volume_id(self):
        """Gets the volume_id of this CreateFolderRequest.  # noqa: E501

        The unique identifier for this Folder's Volume  # noqa: E501

        :return: The volume_id of this CreateFolderRequest.  # noqa: E501
        :rtype: str
        """
        return self._volume_id

    @volume_id.setter
    def volume_id(self, volume_id):
        """Sets the volume_id of this CreateFolderRequest.

        The unique identifier for this Folder's Volume  # noqa: E501

        :param volume_id: The volume_id of this CreateFolderRequest.  # noqa: E501
        :type: str
        """

        self._volume_id = volume_id

    @property
    def volume_name(self):
        """Gets the volume_name of this CreateFolderRequest.  # noqa: E501

        The unique name for the Folder's Volume  # noqa: E501

        :return: The volume_name of this CreateFolderRequest.  # noqa: E501
        :rtype: str
        """
        return self._volume_name

    @volume_name.setter
    def volume_name(self, volume_name):
        """Sets the volume_name of this CreateFolderRequest.

        The unique name for the Folder's Volume  # noqa: E501

        :param volume_name: The volume_name of this CreateFolderRequest.  # noqa: E501
        :type: str
        """

        self._volume_name = volume_name

    @property
    def acl(self):
        """Gets the acl of this CreateFolderRequest.  # noqa: E501

        Optional array to replace the acl on the resource.  # noqa: E501

        :return: The acl of this CreateFolderRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._acl

    @acl.setter
    def acl(self, acl):
        """Sets the acl of this CreateFolderRequest.

        Optional array to replace the acl on the resource.  # noqa: E501

        :param acl: The acl of this CreateFolderRequest.  # noqa: E501
        :type: list[str]
        """

        self._acl = acl

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateFolderRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateFolderRequest):
            return True

        return self.to_dict() != other.to_dict()
